<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Aplikasi Vue #7: Direktif untuk Perulangan</title>
  <!-- Menyisipkan Vuejs dari CDN -->
</head>

<body>

  <!-- elemen kontainer untuk aplikasi -->
  <div id="app">
    <form @submit.prevent="submitForm()">
        <p v-if="errors.length ">
            <b>Please Correct the following errors</b>
            <ul>
                <li v-for="error in errors">{{ error }}</li>
            </ul>
        </p>
        <label>Name : </label>
        <input :disabled="buttonStatus == 'upload'"  type="text" name="name" ref="name" v-model="name"> <br> <br>
        <label>Address : </label>
        <input :disabled="buttonStatus == 'upload'" type="text" name="address" ref="address" v-model="address"> <br> <br>
        <label>No Hp : </label>
        <input :disabled="buttonStatus == 'upload'" type="number" name="no_hp" ref="no_hp" v-model="no_hp"> <br> <br>
        <div v-if="buttonStatus == 'submit'">
            <input type="submit" value="SUBMIT">
        </div>
        <div v-else-if="buttonStatus == 'update'">
            <input type="button" value="UPDATE" @click="updateMember(idEditMember)">
            <input type="button" value="CANCEL" @click="clearForm()">
        </div>
        <div v-else-if="buttonStatus == 'upload'">
            <input type="file" name="photo_profile" ref="photo_profile">
            <input type="button" value="UPLOAD" @click="submitPhoto(idUploadMember)">
            <input type="button" value="CANCEL" @click="clearForm()">
        </div>
    </form>

    <br><br>

    <table border="1">
        <tr v-for="member in members">
            
            <td>
                <b>Name : </b> {{ member.name }} <br>
                <b>Addres : </b> {{ member.address }} <br>
                <b>No hp : </b> {{ member.no_hp }} <br>
            </td>
            <td>
                <button @click="editMember(member)">Edit</button>
                <button @click="removeMember(member.id)">Hapus</button>
                <button @click="uploadPhoto(member)">Upload</button>
            </td>
        </tr>
    </table>
  </div>

  <script src="https://cdn.jsdelivr.net/npm/vue"></script>
  <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>

  <script>
    var app = new Vue({
      el: "#app",
      data: {
        name : '',
        address : '',
        no_hp : '',
        photo_profile : '',
        errors : [],
        members : [],
        buttonStatus : 'submit',
        idEditMember : null,
        idUploadMember : null
      },
      methods: {
          validationForm : function() {
              this.errors = []

              if (this.name.length < 2) {
                  this.errors.push('Nama tidak boleh kosong')
                  this.$refs.name.focus()
              }
          },

          clearForm : function() {
              this.name           = '',
              this.address        = '',
              this.no_hp          = '',
              this.buttonStatus   = 'submit',
              this.idEditMember   = null
              this.idUploadMember = null
          },

          submitForm : function() {
              this.validationForm()

              if (this.errors.length === 0) {

                let formData = new FormData()
                formData.append('name', this.name)
                formData.append('address', this.address)
                formData.append('no_hp', this.no_hp)

                const config = {
                    method: "post",
                    url : "http://demo-api-vue.sanbercloud.com/api/member",
                    data : formData
                }

                axios(config)
                .then( (response) => {
                    this.clearForm()
                    this.getMembers()
                    alert("data di masukkan")
                } )
                .catch( (error) => {
                    console.log(error)
                } )
                    
                }
          },
          
          getMembers : function(){
            const config = {
                methods: "get",
                url : "http://demo-api-vue.sanbercloud.com/api/member"
            }

            axios(config)
            .then( (response) => {
                this.members = response.data.members
            } )
            .catch( (error) => {
                console.log(error)
            } )

          },

          removeMember : function(id) {
            const config = {
                method: "post",
                url   : `http://demo-api-vue.sanbercloud.com/api/member/${id}?_method=DELETE`,
                params : { _method : "DELETE"}
            }

            axios(config)
            .then( (response) => {
                this.getMembers()
                alert("Data berhasil di hapus")
            })
            .catch( (error) => {

            })
            console.log(id)
          },

          editMember : function(member) {
              this.name    = member.name,
              this.address = member.address,
              this.no_hp   = member.no_hp,
              this.buttonStatus = 'update',
              this.idEditMember = member.id
          },

          updateMember : function(id) {
            this.validationForm()
            if (this.errors.length === 0) {
                let formData = new FormData
                formData.append('name', this.name)
                formData.append('address', this.address)
                formData.append('no_hp', this.no_hp)

                let config = {
                    method : "post",
                    url : `http://demo-api-vue.sanbercloud.com/api/member/${id}?_method=PUT`,
                    params : {_method : 'PUT'},
                    data : formData
                }

                axios(config)
                .then( (response) => {
                    this.clearForm()
                    this.getMembers()
                    alert('Data berhasil di update')
                })
                .catch( (error) => {
                    console.log(error)
                })
            }
          },

          uploadPhoto : function(member) {
              this.name           = member.name,
              this.address        = member.address,
              this.no_hp          = member.no_hp,
              this.buttonStatus   = 'upload',
              this.idUploadMember = member.id
          },

          submitPhoto : function(id) {
            let file = this.$refs.photo_profile.files[0]

            let formData = new FormData
            formData.append('photo_profile', file)

            let config = {
                method : "post",
                url : `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                data : formData
            }

            axios(config)
            .then( (response) => {
                this.clearForm()
                this.getMembers()
                alert('File berhasil di upload')
            })
            .catch( (error) => {
                console.log(error)
            })
          }
      },

      created() {
          this.getMembers()
      }
    })
  </script>
</body>

</html>